#ifndef INCLUDE_H_SAXATTRIBUTESADAPTOR
#define INCLUDE_H_SAXATTRIBUTESADAPTOR

#include <msxml2.h>
#include <atlcomcli.h>

#include "tstring.hpp"
#include "SAXAttributes.hpp"

class SAXAttributesAdaptor : public SAXAttributes
{
public:
	SAXAttributesAdaptor( ISAXAttributes* v_source );
	SAXAttributesAdaptor( IMXAttributes* v_source );
	virtual ~SAXAttributesAdaptor();

	virtual int getLength() const;
	virtual tstring getURI(int) const;
	virtual tstring getLocalName(int) const;
	virtual tstring getQName(int) const;
	virtual void getName(int, tstring*, tstring*, tstring* ) const;
	virtual int getIndexFromName( const tstring&, const tstring& ) const;
	virtual int getIndexFromQName( const tstring& ) const;
	virtual tstring getType(int) const;
	virtual tstring getTypeFromName( const tstring&, const tstring& ) const;
	virtual tstring getTypeFromQName( const tstring& ) const;
	virtual tstring getValue(int) const;
	virtual tstring getValueFromName( const tstring&, const tstring& ) const;
	virtual tstring getValueFromQName( const tstring& ) const;

private:
	CComQIPtr<ISAXAttributes> source_;
};


#endif
